; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    atol PROTO :DWORD

    .code       ; code section

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

atol proc lpSrc:DWORD

    xor eax, eax
    mov edx, [esp+4]            ; lpSrc
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"
    jne lbl0
    add eax, 1
    movzx ecx, BYTE PTR [edx]
    add edx, 1
  lbl0:
    mov [esp+4], eax            ; keep sign on stack
    xor eax, eax
    sub ecx, 48
    jc  lbl2

  lbl1:
    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jc  lbl2

    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jnc  lbl1

  lbl2:
    mov ecx, [esp+4]            ; retrieve sign
    test ecx, ecx
    jz lbl3
    neg eax                     ; negative return value is sign set
  lbl3:

    ret 4

atol endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end
