; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    atol_ex PROTO :DWORD

    .code       ; code section

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

atol_ex proc lpSrc:DWORD

    xor eax, eax
    mov edx, [esp+4]
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"
    jne lbl0
    add eax, 1
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    jmp lbl0

  pre:
    mov ecx, [esp+4]            ; retrieve sign
    test ecx, ecx
    jz lbl3
    neg eax                     ; negate return value if sign set
  lbl3:
    ret 4

  lbl0:
    mov [esp+4], eax            ; keep sign on stack
    xor eax, eax
    sub ecx, 48
    jc  pre
    sub edx, 1

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+1]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+2]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+3]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+4]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+5]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+6]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+7]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+8]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+9]
    sub ecx, 48
    jc pre

    lea eax, [eax+eax*4]
    lea eax, [ecx+eax*2]
    movzx ecx, BYTE PTR [edx+10]
    sub ecx, 48
    jc pre

    ret 4

atol_ex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end
