; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    ltoa PROTO :DWORD,:DWORD

    .code       ; code section

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

ltoa proc dwValue:DWORD, lpBuffer:DWORD

    mov eax, [esp+4]        ; dwValue
    mov ecx, [esp+8]        ; lpBuffer

    push ebx
    push esi
    push edi

    test eax, eax
    jns pos
    jnz sign

  zero:
    mov word ptr [ecx], 30h
    pop edi
    pop esi
    pop ebx

    ret 8

  sign:
    mov byte ptr [ecx],'-'
    neg eax
    add ecx, 1

  pos:
    mov edi, 0CCCCCCCDh         ; 3435973837
    mov esi, ecx

    cmp eax, 0
    jbe lb1

  lb0:
    mov ebx, eax
    mul edi                     ; MUL eax * edi
    shr edx, 3                  ; DIV remainder in EDX by 8
    mov eax, edx

    lea edx, [edx+eax*8]
    add edx, eax                ; EDX * 10

    sub ebx, edx
    add ebx, 48

    mov [ecx], bl               ; write BYTE to buffer
    add ecx, 1
    cmp eax, 0
    ja lb0


  lb1:
    mov byte ptr [ecx], 0       ; terminate the string

  ; We now have all the digits, but in reverse order.

    cmp esi, ecx
    jnb dtaexit

  REPEAT 10
    sub ecx, 1
    movzx eax, BYTE PTR [esi]
    movzx ebx, BYTE PTR [ecx]
    mov [ecx], al
    mov [esi], bl
    add esi, 1
    cmp esi, ecx
    jnb dtaexit
  ENDM

  dtaexit:

    pop edi
    pop esi
    pop ebx

    ret 8

ltoa endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end
